// This file is generated by kconfig_compiler_kf5 from freememorynotifier.kcfg.
// All changes you do to this file will be lost.
#ifndef FREEMEMORYNOTIFIERSETTINGS_H
#define FREEMEMORYNOTIFIERSETTINGS_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class FreeMemoryNotifierSettings : public KConfigSkeleton
{
  public:

    static FreeMemoryNotifierSettings *self();
    ~FreeMemoryNotifierSettings() override;

    /**
      Set Minimum free memory percentage before user starts being notified.
    */
    static
    void setMinimumSpace( int v )
    {
      if (v < 0)
      {
        qDebug() << "setMinimumSpace: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 100)
      {
        qDebug() << "setMinimumSpace: value " << v << " is greater than the maximum value of 100";
        v = 100;
      }

      if (!self()->isMinimumSpaceImmutable())
        self()->mMinimumSpace = v;
    }

    /**
      Get Minimum free memory percentage before user starts being notified.
    */
    static
    int minimumSpace()
    {
      return self()->mMinimumSpace;
    }

    /**
      Is Minimum free memory percentage before user starts being notified. Immutable
    */
    static
    bool isMinimumSpaceImmutable()
    {
      return self()->isImmutable( QStringLiteral( "minimumSpace" ) );
    }

    /**
      Set Is the free memory notification enabled.
    */
    static
    void setEnableNotification( bool v )
    {
      if (!self()->isEnableNotificationImmutable())
        self()->mEnableNotification = v;
    }

    /**
      Get Is the free memory notification enabled.
    */
    static
    bool enableNotification()
    {
      return self()->mEnableNotification;
    }

    /**
      Is Is the free memory notification enabled. Immutable
    */
    static
    bool isEnableNotificationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "enableNotification" ) );
    }

    /**
      Set Is the swap space counted as memory.
    */
    static
    void setSwapIncluded( bool v )
    {
      if (!self()->isSwapIncludedImmutable())
        self()->mSwapIncluded = v;
    }

    /**
      Get Is the swap space counted as memory.
    */
    static
    bool swapIncluded()
    {
      return self()->mSwapIncluded;
    }

    /**
      Is Is the swap space counted as memory. Immutable
    */
    static
    bool isSwapIncludedImmutable()
    {
      return self()->isImmutable( QStringLiteral( "swapIncluded" ) );
    }

  protected:
    FreeMemoryNotifierSettings();
    friend class FreeMemoryNotifierSettingsHelper;


    // General
    int mMinimumSpace;
    bool mEnableNotification;
    bool mSwapIncluded;

  private:
};

#endif

