/* This file is part of the KDE Project
   Copyright (c) 2006 Lukas Tinkl <ltinkl@suse.cz>
   Copyright (c) 2008 Lubos Lunak <l.lunak@suse.cz>
   Copyright (c) 2009 Ivo Anjo <knuckles@gmail.com>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _FREEMEMORYNOTIFIER_H_
#define _FREEMEMORYNOTIFIER_H_

#include <QtCore/QTimer>
#include <QtDBus/QDBusInterface>

#include <processcore/process.h>
#include <processcore/processes.h>

#include "oomd_interface.h"

class KNotification;
class KStatusNotifierItem;

class FreeMemoryNotifier : public QObject
{
    Q_OBJECT

public:
    FreeMemoryNotifier(QObject *parent = NULL);
    ~FreeMemoryNotifier() override;

public Q_SLOTS:
    Q_SCRIPTABLE Q_NOREPLY void reload();

private Q_SLOTS:
    void createNotification();
    void closeNotification();
    void updateMenu();
    void checkFreeMemory();
    void showTaskManager();
    void killProcess();
    void Killed(QString cgroup, QString reason);

private:
    QTimer *m_timer;
    KNotification *m_notification;
    qint64 m_lastAvail; // used to suppress repeated warnings when available space hasn't changed
    const KSysGuard::Process *m_process;
    KSysGuard::Processes *m_processes;

    int m_threshold;
    bool m_swapIncluded;
    bool m_enableNotification;
    OrgFreedesktopOom1ManagerInterface *m_iface;
    KNotification *m_oomdNotification;
};

#endif
